// NavNumbers.cpp: implementation of the NavNumbers class.
//
//////////////////////////////////////////////////////////////////////

#include "ApplicationInterface.h"
#include "NavNumbers.h"

#include "Navigator.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

//RECT RECT_SCREEN = {0,0,240,294};

#define BUTTON_WIDTH 20
#define BUTTON_HEIGHT 17

#define PADDING_WIDTH 3
#define PADDING_HEIGHT 3

#define MAXHORIZONTAL 10
#define MAXVERTICAL 10
#define MAXNUMBERS (MAXVERTICAL*MAXHORIZONTAL)

#define ROW0 15
#define ROW1 30
#define ROW2 45
#define LASTROW 240

NavNumbers::NavNumbers(Navigator* navigator) {
	this->navigator=navigator;
}

NavNumbers::~NavNumbers() {
}

void NavNumbers::show(int maxNumber, UString command) {
	this->maxNumber=maxNumber;
	this->command=command;
	start=1;
}

void NavNumbers::paint() {
	RECT rt;
	memset(&rt,0,sizeof(rt));
	rt.right=RECT_SCREEN.right;

	//to see if the whole screen gets filled
	//rt.bottom=RECT_SCREEN.bottom;
	//setBackground(0x00000000);
	//drawText(&rt,UString(L"test"));
	//resetBackground();
	//

	rt.bottom=ROW0;
	clearRect(&rt);
	
	rt.top=ROW0; rt.bottom=ROW1;
	drawText(&rt,command);

	rt.top=ROW1; rt.bottom=ROW2;
	clearRect(&rt);

	TCHAR buttonText[4];
	setBackground(BUTTON_BACKGROUND);
	setFont(FONT_NAVIGATION);
	int current=start;
	while ((current<=maxNumber)&&(current<start+MAXNUMBERS)) {
		int rowStart=current;
		rt.top=rt.bottom; rt.bottom=rt.top+BUTTON_HEIGHT; rt.right=0;
		while ((current<=maxNumber)&&(current-rowStart<MAXHORIZONTAL)) {
			//padding left of button
			rt.left=rt.right;rt.right=rt.left+PADDING_WIDTH;
			clearRect(&rt);
			//button
			rt.left=rt.right;rt.right=rt.left+BUTTON_WIDTH;
			_itow(current,buttonText,10);
			drawRText(&rt,buttonText,wcslen(buttonText));
			current++;
		}
		//padding right of buttons
		rt.left=rt.right;rt.right=RECT_SCREEN.right;
		clearRect(&rt);
		//padding below buttons
		rt.left=0; rt.top=rt.bottom; rt.bottom=rt.top+PADDING_HEIGHT;
		clearRect(&rt);
	}
	//optional 'more' button
	if ((start!=1)||(current<maxNumber)) {
		rt.top=rt.bottom; rt.bottom=ROW2+MAXVERTICAL*(BUTTON_HEIGHT+PADDING_HEIGHT);
		clearRect(&rt);
		rt.top=rt.bottom; rt.bottom=rt.top+BUTTON_HEIGHT;
		rt.right=(RECT_SCREEN.right/3);
		clearRect(&rt);
		rt.left=rt.right;rt.right=RECT_SCREEN.right-rt.left;
		drawText(&rt,L"More...",7);
		rt.left=rt.right;rt.right=RECT_SCREEN.right;
		clearRect(&rt);
		rt.left=0;
	}
	//space below the buttons
	rt.top=rt.bottom; rt.bottom=RECT_SCREEN.bottom;
	clearRect(&rt);

	setBackground();
	setFont();
}

int NavNumbers::userTap(int x, int y) {
	y=y-ROW2;
	if (y>0) {
		int vertical=(y/(PADDING_HEIGHT+BUTTON_HEIGHT));
		if (vertical<MAXVERTICAL) {
			y=y-vertical*(PADDING_HEIGHT+BUTTON_HEIGHT);
			int horizontal=(x/(PADDING_WIDTH+BUTTON_WIDTH));
			if (horizontal<MAXHORIZONTAL) {
				x=x-horizontal*(PADDING_WIDTH+BUTTON_WIDTH);
				//button is in upper right corner
				if ((x>=PADDING_WIDTH)&&(y<=BUTTON_HEIGHT)) {
					int current=vertical*MAXHORIZONTAL+horizontal+start;
					if (current<=maxNumber) return current;
				}
			}
		}
		else if (vertical==MAXVERTICAL) { // The 'more' button is here
			y=y-vertical*(PADDING_HEIGHT+BUTTON_HEIGHT);
			if (y<=BUTTON_HEIGHT) {
				if (((2*x)>=(RECT_SCREEN.right-x))&&((2*(RECT_SCREEN.right-x))>=x)) {
					if ((start+MAXNUMBERS)>maxNumber)
						start=1;
					else
						start=start+MAXNUMBERS;
					refreshScreen();
				}
			}
		}
	}
	return -1;
}
